=== modified file '.bzrignore'
--- .bzrignore	2014-12-09 21:43:34 +0000
+++ .bzrignore	2016-05-13 18:30:55 +0000
@@ -3,3 +3,4 @@
 bin/
 .coverage
 .venv
+.tox

=== added file '.coveragerc'
--- .coveragerc	1970-01-01 00:00:00 +0000
+++ .coveragerc	2016-05-13 18:30:55 +0000
@@ -0,0 +1,6 @@
+[report]
+# Regexes for lines to exclude from consideration
+exclude_lines =
+    if __name__ == .__main__.:
+include=
+    hooks/memcached*

=== modified file 'hooks/memcached_hooks.py'
--- hooks/memcached_hooks.py	2015-11-23 00:10:14 +0000
+++ hooks/memcached_hooks.py	2016-05-13 18:30:55 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/env python
+#!/usr/bin/env python3
 import re
 import os
 import shutil

=== added file 'setup.cfg'
--- setup.cfg	1970-01-01 00:00:00 +0000
+++ setup.cfg	2016-05-13 18:30:55 +0000
@@ -0,0 +1,5 @@
+[nosetests]
+verbosity=2
+with-coverage=1
+cover-erase=1
+cover-package=hooks

=== added file 'test-requirements-py2.txt'
--- test-requirements-py2.txt	1970-01-01 00:00:00 +0000
+++ test-requirements-py2.txt	2016-05-13 18:30:55 +0000
@@ -0,0 +1,9 @@
+nose==1.3.1
+Jinja2==2.7
+mock==1.0.1
+PyYAML==3.10
+six==1.5.2
+coverage==3.7.1
+flake8==2.1.0
+simplejson
+charm-tools

=== added file 'test-requirements-py3.txt'
--- test-requirements-py3.txt	1970-01-01 00:00:00 +0000
+++ test-requirements-py3.txt	2016-05-13 18:30:55 +0000
@@ -0,0 +1,7 @@
+nose==1.3.7
+Jinja2==2.8
+mock==1.3.0
+PyYAML==3.11
+six==1.10.0
+coverage==3.7.1
+flake8==2.5.4

=== added file 'tox.ini'
--- tox.ini	1970-01-01 00:00:00 +0000
+++ tox.ini	2016-05-13 18:30:55 +0000
@@ -0,0 +1,38 @@
+[tox]
+envlist = pep8,py27,py34,py35
+skipsdist = True
+
+[testenv]
+setenv = VIRTUAL_ENV={envdir}
+         PYTHONHASHSEED=0
+install_command =
+  pip install --allow-unverified python-apt {opts} {packages}
+commands = nosetests -s --nologcapture {posargs} unit_tests/
+
+# trusty
+[testenv:py27]
+basepython = python2.7
+deps = -r{toxinidir}/test-requirements-py2.txt
+
+# trusty
+[testenv:py34]
+basepython = python3.4
+deps = -r{toxinidir}/test-requirements-py3.txt
+
+# xenial
+[testenv:py35]
+basepython = python3.5
+deps = -r{toxinidir}/test-requirements-py3.txt
+
+[testenv:pep8]
+basepython = python2.7
+deps = -r{toxinidir}/test-requirements-py2.txt
+commands = flake8 {posargs} hooks unit_tests tests
+           charm-proof
+
+[testenv:venv]
+commands = {posargs}
+
+[flake8]
+ignore = E402,E226
+exclude = hooks/charmhelpers

=== modified file 'unit_tests/test_memcached_hooks.py'
--- unit_tests/test_memcached_hooks.py	2015-07-22 20:13:58 +0000
+++ unit_tests/test_memcached_hooks.py	2016-05-13 18:30:55 +0000
@@ -2,7 +2,7 @@
 import os
 import shutil
 import tempfile
-from test_utils import CharmTestCase
+from unit_tests.test_utils import CharmTestCase, get_default_config
 import memcached_hooks
 
 __author__ = 'Felipe Reyes <felipe.reyes@canonical.com>'
@@ -22,6 +22,7 @@
     'log',
     'oldest_peer',
     'peer_units',
+    'open_port'
 ]
 FREE_MEM_SMALL = """             total       used       free     shared    \
 buffers     cached
@@ -159,23 +160,28 @@
                          self.test_config.config['size'])
         open_port.assert_any_call(configs['tcp-port'], 'TCP')
 
+    @mock.patch('charmhelpers.contrib.network.ufw.modify_access')
+    @mock.patch('charmhelpers.contrib.network.ufw.grant_access')
+    @mock.patch('memcached_utils.config')
     @mock.patch('subprocess.Popen')
     @mock.patch('charmhelpers.core.templating.render')
     @mock.patch('subprocess.check_output')
     @mock.patch('memcached_utils.log')
     def test_config_changed_size_set_0_small(self, log, check_output, render,
-                                             popen):
+                                             popen, mucfg, *args):
         p = mock.Mock()
         p.configure_mock(**{'communicate.return_value': ('stdout', 'stderr'),
                             'returncode': 0})
         popen.return_value = p
 
-        configs = {'size': 0}
+        configs = get_default_config()
+        configs.update({'size': 0})
 
         def f(c):
-            return configs.get(c, None)
+            return configs[c]
 
         self.config.side_effect = f
+        mucfg.side_effect = f
 
         def g(*args, **kwargs):
             if args[0] == ['free', '-m']:
@@ -191,30 +197,35 @@
         self.assertEqual(passed_vars['mem_size'], 1596)
         self.assertFalse(passed_vars['large_pages_enabled'])
 
+    @mock.patch('charmhelpers.contrib.network.ufw.modify_access')
+    @mock.patch('charmhelpers.contrib.network.ufw.grant_access')
+    @mock.patch('memcached_utils.config')
     @mock.patch('subprocess.Popen')
     @mock.patch('charmhelpers.core.templating.render')
     @mock.patch('subprocess.check_output')
     @mock.patch('memcached_utils.log')
     def test_config_changed_size_set_0_big(self, log, check_output, render,
-                                           popen):
+                                           popen, mucfg, *args):
         p = mock.Mock()
         p.configure_mock(**{'communicate.return_value': ('stdout', 'stderr'),
                             'returncode': 0})
         popen.return_value = p
 
-        configs = {'size': 0,
-                   'disable-large-pages': False}
+        configs = get_default_config()
+        configs.update({'size': 0,
+                        'disable-large-pages': False})
 
         def f(c):
-            return configs.get(c, None)
+            return configs[c]
 
         self.config.side_effect = f
+        mucfg.side_effect = f
 
         def g(*args, **kwargs):
             if args[0] == ['free', '-m']:
                 return FREE_MEM_BIG
             if args[0] == ['sysctl', '-n', 'vm.nr_hugepages']:
-                return int(16013 / 2)
+                return int(16013 * 2)
             else:
                 return ""
 
@@ -228,24 +239,30 @@
                                       'vm.nr_hugepages={}'.format(16013/2)])
         self.assertTrue(passed_vars['large_pages_enabled'])
 
+    @mock.patch('charmhelpers.contrib.network.ufw.modify_access')
+    @mock.patch('charmhelpers.contrib.network.ufw.grant_access')
+    @mock.patch('memcached_utils.config')
     @mock.patch('subprocess.Popen')
     @mock.patch('charmhelpers.core.templating.render')
     @mock.patch('subprocess.check_output')
     @mock.patch('memcached_utils.log')
     def test_config_changed_size_failed_set_hpages(self, log, check_output,
-                                                   render, popen):
+                                                   render, popen, mucfg,
+                                                   *args):
         p = mock.Mock()
         p.configure_mock(**{'communicate.return_value': ('stdout', 'stderr'),
                             'returncode': 0})
         popen.return_value = p
 
-        configs = {'size': 0,
-                   'disable-large-pages': False}
+        configs = get_default_config()
+        configs.update({'size': 0,
+                        'disable-large-pages': False})
 
         def f(c):
-            return configs.get(c, None)
+            return configs[c]
 
         self.config.side_effect = f
+        mucfg.side_effect = f
 
         def g(*args, **kwargs):
             if args[0] == ['free', '-m']:
@@ -435,31 +452,31 @@
                                     cache_joined, ufw, unit_get, replica,
                                     open_port):
         params = {
-            'tcp_port': None,
-            'disable_cas': None,
-            'mem_size': None,
-            'factor': None,
-            'connection_limit': None,
-            'udp_port': None,
-            'slab_page_size': None,
-            'threads': None,
+            'tcp_port': 11211,
+            'disable_cas': False,
+            'mem_size': 768,
+            'factor': 1.25,
+            'connection_limit': 1024,
+            'udp_port': 0,
+            'slab_page_size': -1,
+            'threads': -1,
+            'replica': "10.0.0.2",
+            'repcached_port': '11212',
             'large_pages_enabled': False,
-            'min_item_size': None,
-            'repcached_port': '11212',
-            'request_limit': None,
-            'disable_auto_cleanup': None,
+            'min_item_size': -1,
+            'request_limit': -1,
+            'disable_auto_cleanup': False,
         }
 
         dpkg.return_value = True
         replica.return_value = ('10.0.0.2')
 
-        configs = {
-            'repcached': True,
-            'memsize': 1,
-        }
+        configs = get_default_config()
+        configs.update({'repcached': True,
+                        'memsize': 1})
 
         def f(c):
-            return configs.get(c, params.get(c))
+            return configs[c]
 
         self.config.side_effect = f
         self.unit_get.return_value = '10.0.0.1'
@@ -482,32 +499,31 @@
     def test_config_changed_no_replica(self, dpkg, render,
                                        replica, ufw, cache, open_port):
         params = {
-            'tcp_port': None,
-            'disable_cas': None,
-            'mem_size': None,
-            'factor': None,
-            'connection_limit': None,
-            'udp_port': None,
-            'slab_page_size': None,
-            'threads': None,
+            'tcp_port': 11211,
+            'disable_cas': False,
+            'mem_size': 768,
+            'factor': 1.25,
+            'connection_limit': 1024,
+            'udp_port': 0,
+            'slab_page_size': -1,
+            'threads': -1,
             'replica': "10.0.0.2",
             'repcached_port': '11212',
             'large_pages_enabled': False,
-            'min_item_size': None,
-            'request_limit': None,
-            'disable_auto_cleanup': None,
+            'min_item_size': -1,
+            'request_limit': -1,
+            'disable_auto_cleanup': False,
         }
 
         replica.return_value = "10.0.0.2"
         dpkg.return_value = True
 
-        configs = {
-            'repcached': True,
-            'memsize': 1,
-        }
+        configs = get_default_config()
+        configs.update({'repcached': True,
+                        'memsize': 1})
 
         def f(c):
-            return configs.get(c, params.get(c))
+            return configs[c]
 
         self.config.side_effect = f
 

=== modified file 'unit_tests/test_utils.py'
--- unit_tests/test_utils.py	2014-12-01 19:11:26 +0000
+++ unit_tests/test_utils.py	2016-05-13 18:30:55 +0000
@@ -37,7 +37,7 @@
     '''
     default_config = {}
     config = load_config()
-    for k, v in config.iteritems():
+    for k, v in config.items():
         if 'default' in v:
             default_config[k] = v['default']
         else:

